#ifndef __GFX_H__
#define __GFX_H__

#define BLACK       0x00000000
#define GREEN4      0x0000c000
#define PINK        0x00ffc0c0
#define GOLD        0x00ffd700
#define BROWN       0x00c06000
#define LIGHT_BLUE  0x0087ceFF
#define BLUE        0x000000FF
#define GREEN       0x0000FF00
#define CYAN        0x0000FFFF
#define RED         0x00FF0000
#define MAGENTA     0x00FF00FF
#define YELLOW      0x00FFFF00
#define WHITE       0x00FFFFFF
#define GRAY25      0x00404040
#define GRAY50      0x00808080
#define GRAY75      0x00C0C0C0

typedef struct {
  float x, y;
} vector_t;

int init_gfx (int width, int height, int bpp, int fullscreen);
/* Initialize video mode.
 *  width          : screen or window width
 *  height         : screen or window height
 *  bpp            : bits per pixel = 8, 16, 24 or 32
 *  fullscreen = 1 : full screen
 *             = 0 : windowed mode
 * Returns 0 if succeed, -1 otherwise.
 */

int update_display (void);
/* Swaps screen buffers.
 * Precondition: init_gfx must have been called
 * Returns 0 if succeed, -1 otherwise.
 */

int save_display (char *file_name);
/* Save image in a file.
 * Returns 0 if succeed.
 */
   
int rectangle (int x, int y, unsigned w, unsigned h, unsigned color);
/* Draw a filled rectangle at coordinates ( x, y ) with dimensions w x h
 * Returns 0 if succeed, -1 otherwise.
 */

void done_gfx (void);
/* Close window or restore video mode */

#endif
