#include "config.h"

/*********************************************/
/* linear loops */
// heads
#define IHead "h3"
#define CHead "l3"

// grow actions
#define Grow2  "dd"
#define Grow3  "d" Grow2
#define Grow4  "d" Grow3
#define Grow5  "d" Grow4
#define Grow6  "d" Grow5
#define Grow7  "d" Grow6
#define Grow8  "d" Grow7
#define Grow9  "d" Grow8
#define Grow10 "d" Grow9
#define Grow11 "d" Grow10
#define Grow12 "d" Grow11

// parenthesis
#define Start IHead
#define End "333333333333"
#define End2 End End
#define End3 End2 End

// sides
#define Side2  Grow2  IHead
#define Side3  Grow3  IHead
#define Side4  Grow4  IHead
#define Side5  Grow5  IHead
#define Side6  Grow6  IHead
#define Side7  Grow7  IHead
#define Side8  Grow8  IHead
#define Side9  Grow9  IHead
#define Side10 Grow10 IHead
#define Side11 Grow11 IHead
#define Side12 Grow12 IHead

// clokwise gene
#define C2  Grow2  CHead
#define C3  Grow3  CHead
#define C4  Grow4  CHead
#define C5  Grow5  CHead
#define C6  Grow6  CHead
#define C7  Grow7  CHead
#define C8  Grow8  CHead
#define C9  Grow9  CHead
#define C10 Grow10 CHead
#define C11 Grow11 CHead
#define C12 Grow12 CHead

// inverse-clokwise gene
#define I2  Grow2  IHead
#define I3  Grow3  IHead
#define I4  Grow4  IHead
#define I5  Grow5  IHead
#define I6  Grow6  IHead
#define I7  Grow7  IHead
#define I8  Grow8  IHead
#define I9  Grow9  IHead
#define I10 Grow10 IHead
#define I11 Grow11 IHead
#define I12 Grow12 IHead

/*********************************************/
/* small loops */
// small invclk loops
#define SmallI End I2 Side2 Side2 Side2 Start
// small clk loops
#define SmallC End C2 Side2 Side2 Side2 Start

// fast small invclk loops
#define FastI End I2 I2 I2 Side2 Side2 Side2 Start
// fast small clk loops
#define FastC End C2 C2 C2 Side2 Side2 Side2 Start

/*********************************************/
// evolution from speed
#define SpeedEvo End3 C2 C2 C2 C2 C2 C2 C2 Side12 Side12 Side12 Start


/*********************************************/
// evolution from shape
#define ShapeEvo End2 C6 C4 C6 I12 Side12 Side12 Side12 Start


/*********************************************/
// the line
//#define Line SpeedEvo
#define Line ShapeEvo

/*********************************************/
static char *lineLoop[] = {Line};

void build_simulation (void)
{
#ifndef DESTRUCTION
   context_error ("DESTRUCTION should be defined");
#endif
   build_loop (1,lineLoop,INITX,INITY);
}
